/ states are triples
evalmed:{[mystate]
 totscenarios: sum mystate[;0];
 / allcumuls: (asc mystate[;1]),'sums (mystate[iasc mystate[;1];0];
	/ sort the states based on their cumulative interest rates
	/ and then get the number in each case and then get running sums
	/ of multiplicities
 / i25: allcumuls[;1] bin (0.25 * totscenarios);
 / i50: allcumuls[;1] bin (0.50 * totscenarios);
 / i75: allcumuls[;1] bin (0.75 * totscenarios);
 / (allcumuls[i50;1]; allcumuls[i25]; allcumuls[i75]) }
 5}
 
 
/ Find the median of the net interest rates
/ over n years assuming the current interest rate is curintrate
/ and each year it can go up or down by increment or stay the same.
monte:{[n; curintrate; increment]
 mystate: enlist(1; 1; 0); / num instances, cumulative interest, last interest
 x: (0; increment%100; neg (increment%100));
 i: 0;
 while[i < n;
   j: 0;
   newstate: ();
   while[j < count mystate;
     lastint: mystate[j;2];
     nextint: lastint-increment;
     newstate,: enlist (mystate[j;0]; mystate[j;1]*(1+nextint);nextint);
     nextint: lastint;
     newstate,: enlist (mystate[j;0]; mystate[j;1]*(1+nextint);nextint);
     nextint: lastint+increment;
     newstate,: enlist (mystate[j;0]; mystate[j;1]*(1+nextint);nextint);
     j+: 1;
   ];
   g: group (newstate[;1]),'(newstate[;2]); / cumulative int and last int
   multiplicities: sum each newstate[value g;0];
   mystate: multiplicity,'((key g)[;0]);((key g)[;1]);
   i+: 1;
 ];
 evalmed[mystate]}



/ EXECUTION

nums: "F"$ .z.x
monte[floor nums[0]; nums[1]; nums[2]]
